package MultiCastZoo;
import java.io.*;
import java.net.MulticastSocket;
import java.net.InetAddress;
import java.net.DatagramPacket;
import java.net.SocketException;
import java.net.SocketTimeoutException;
import java.security.SecureRandom;
import java.security.MessageDigest;
import java.net.Socket;
import java.math.BigInteger;
import java.net.ServerSocket;

/**
 * Multicast Zoo - A vulnerable distributed zoo system
 * with protected command execution.
 * Written for a security exercise in
 * Computer Network Security  (ECE 6612 Spring 2008)
 * at Georgia Tech
 * @author David Bauer and Chris Lee
 *
 */
public class TestPatched{
	static MulticastSocket sock;
	static InetAddress group;
	static int incoming_port = 446;
	static final int outgoing_port = 446;

	static void sendMsg(String msg) {
		byte [] buf = msg.getBytes();
		DatagramPacket packet = new DatagramPacket(buf, 0, buf.length, group, outgoing_port);
		System.out.println("Sending: \"" + msg + "\"");
		try {
			sock.send(packet);
		} catch(IOException e) {}
	}
	public static String toMD5(String in) throws java.security.NoSuchAlgorithmException
        {
            MessageDigest md5 = MessageDigest.getInstance("MD5");
            byte[] in_md5 = md5.digest(in.getBytes());
            BigInteger in_md5_num = new BigInteger(1, in_md5);
            String in_md5_hex = in_md5_num.toString(16);
            return in_md5_hex;
        }

	public static void main(String[] args) {
	       try{
		if (args.length != 0)
		{
			incoming_port = Integer.parseInt(args[0]);
		}
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		System.out.print("Password:");
		String password = in.readLine();
		    sock = new MulticastSocket(incoming_port);
		    group = InetAddress.getByName("230.0.0.1");
		    try {
		    	sock.joinGroup(group);
		    } catch (SocketException e) {
		    	System.out.println("Caught exception while trying to join multicast group: " + e);
		    	System.out.println("Please check your network settings.  Multicast must be enabled and routable.");
		    	return;
		    }
		    sendMsg("CMDReq");
		    System.out.println("Sent request, waiting for reply");
		    byte[] buf = new byte[1472];
		    String received = "";
		    while (received == "")
		    {
		        DatagramPacket packet = new DatagramPacket(buf, buf.length);
		        sock.receive(packet);
                        received = new String(packet.getData(), packet.getOffset(), packet.getLength());
			if(!received.startsWith("CMDRep"))
			{
				received = "";
			}
		    }
		    System.out.println("Received:"+received);
		    String [] parts = received.split(",");
		    String challenge = parts[1];
		    System.out.println("Challenge was:"+challenge);
                    String resp = toMD5(challenge + password);
		    String outMsg = "CMDAuth,"+resp+","+challenge+",127.0.0.1,8080,ls -ltr";
		    System.out.println("sending:"+outMsg);
		    sendMsg(outMsg);
	       }
	       catch (Exception e)
	       {
			System.out.println(e);
	       }
	}
}

		

